/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************/
#ifndef synaps_arithm_infinity_h
#define synaps_arithm_infinity_h
//--------------------------------------------------------------------
#include <iostream>
#include <cstdlib>
#include <synaps/init.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
/** \file                                                           */
/**
   Class used to represent (+/-)infinity. 
**/
struct Infinity
{
  int sign;
  Infinity():sign(1){}
  Infinity(int x):sign(x){}
  Infinity(const Infinity& x):sign(x.sign){}
  Infinity operator=(const Infinity& x){sign=x.sign;return *this;};

};

//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
#endif // SYNAPS_ARITHM_ZP_H

