/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 ********************************************************************/
#ifndef synaps_arithm_Ring_h
#define synaps_arithm_Ring_h
//===================================================================
#include <string>
#include <synaps/init.h>
//===================================================================
__BEGIN_NAMESPACE_SYNAPS
//===================================================================

template<class X> struct Ring
{
  typedef X T;
  Ring(){}
  Ring(const Ring<X>& t) {}
  Ring(const X& x) {}
  inline std::string str() { return "Ring"; }
};

template<class C> inline Ring<C> make_ring(const C& c) { return Ring<C>(); }

template<> inline std::string Ring<int>::str()    { return "II"; }
template<> inline std::string Ring<double>::str() { return "DD"; }

//===================================================================
__END_NAMESPACE_SYNAPS
#endif //
