
/// \file 
#ifndef SYNAPS_NUMERICS_VARIOUS_DEFS_H
#define SYNAPS_NUMERICS_VARIOUS_DEFS_H

#include <synaps/init.h>
#include <synaps/base/TypeTests.h>
#include <synaps/base/comparison.h>
__BEGIN_NAMESPACE_SYNAPS

/** 
	* @brief The true tag
	*/
typedef Type::true_t Tag_true;
//struct Tag_true  {};

/** 
	* @brief The false tag
	*/
typedef Type::false_t Tag_false;
//struct Tag_false {};


/** 
	* @brief These functions check the validity of a tag. 
	* 
	* @param Tag_true 
	* 
	* @return true
	*/
inline bool check_type( Tag_true  ) { return true;  }

/** 
	* @brief These functions check the validity of a tag. 
	* 
	* @param Tag_false 
	* 
	* @return false
	*/
inline bool check_type( Tag_false ) { return false; }



__END_NAMESPACE_SYNAPS

#endif // SYNAPS_NUMERICS_VARIOUS_DEFS_H

