#include <iostream>
#include <synaps/linalg/MatrDse.h>
#include <synaps/linalg/lapack.h>
#include <synaps/linalg/Eigen.h>
#include <synaps/linalg/Svd.h>

typedef VectDse<double> vect_t;
typedef MatrDse<double,lapack::rep2d<double> > matr_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  matr_t A(3,3,"1 2 3 4 5 6 7 8 9",ByRow());
  std::cout<<A<<std::endl;

  col(A,1) = col(A,0);
  std::cout<<A<<std::endl;

  row(A,1) = row(A,1) - row(A,0)*4;
  std::cout<<A<<std::endl;

  vect_t V1 = col(A,1)*2; 
  std::cout<<V1<<std::endl;

  vect_t V2= row(A,0)+ row(A,1);
  std::cout<<V2<<std::endl;

  vect_t W = V2+V2;
  std::cout<<W<<std::endl;
}

