#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include <synaps/arithm/gmp.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/usolve/Aberth.h>

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  UPolDse<QQ> p("1"), l("x-1");
  for(unsigned i=0;i<20;i++) {p*=l;l-=QQ(1);}

  cout<<p<<endl;
  cout<<solve(p, SlvAberth<RR>())<<endl;;
  cout<<solve(p, SlvAberth<CC>())<<endl;;

  QQ eps(1);  for(unsigned i=0;i<19;i++) {eps/=10;}
  p+=(UPolDse<QQ>("x^19")*eps);

  cout<<p<<endl;
  cout<<solve(p, SlvAberth<RR>())<<endl;;
  cout<<solve(p, SlvAberth<CC>())<<endl;;
}
#else
int main(int argc, char** argv) {}
#endif
