/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
History: 
$Id: MatrStr.C,v 1.1 2005/07/11 08:33:34 mourrain Exp $
**********************************************************************/
#include <vector>
#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS




template<class R>
MatrStr<R>::MatrStr(unsigned m, unsigned n,  char * s)
{ 
  std::istringstream ins(s);
  value_type c;  
  std::vector<value_type> l;
  for(size_type i=0; ins.good(); i++)
    {
      ins>> c; l.push_back(c);
    }
  rep()=R(m,n,&l[0]);
}



__END_NAMESPACE_SYNAPS

