#include "synaps/linalg/VectDse.h"  
#include "synaps/linalg/MatrDse.h"  

typedef VectDse<double> vector_t; 
  // Vector definition.
typedef MatrDse<double> matrix_t;
  // Marix definition.

int main(int argc, char** argv) {

  using std::cout;
  using std::cin;
  using std::endl;

  double v[]={1,-3,1,2,3,4,2,2,4,5,5,5,5,-2, 1,2,3,1, -2.8,-2.4,1,.2,5.8};
  matrix_t A(4,4,v, ByRow()), 
      B(4,4,"1 2 1 1 3 4 2 2 5 5 5 5 -2  1 2 3 1  .2 5.8", ByCol());

  cout<<"A="<<A<<", B="<<B<<endl;
  
  col(A,1) = row(A,1);
  std::cout << A << std::endl;
  
  cout <<"Conversion: "<<let::convert(A,type::As<Seq<vector_t> >())<<endl;
  
  vector_t V(v+1,v+5);      cout<<"V="<<V<<endl;
  vector_t W=row(A,0);     cout<<"W="<<W<<endl;


}
