
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename pol>
typename pol::monom_t choice_old(const pol & p)
{
  typename pol::const_iterator iter,stockpos=p.end();
  typename pol::coeff_t max=0;
  static int tmp=0;
  if (tmp<2) {return typename pol::monom_t(tmp++,2);};
  for(iter=p.begin();iter!=p.end();iter++)
    if(iter->GetDegree()==Degree(p))
      {
	if(iter->GetCoeff()*iter->GetCoeff()>max) {
	  max=iter->GetCoeff()*iter->GetCoeff();
	  //	  cout<<"newmax "<<max<<endl;
	  //	  cout<<" les monomes "<<*iter<<endl;
	  stockpos=iter;
	}
      }
  //break;
  //return *iter;
  return *stockpos;
}

template<typename pol>
typename pol::monom_t choice_naif(const pol & p)
{
  typename pol::const_iterator iter,stockpos=p.end();
  typename pol::coeff_t max(0);
  for(iter=p.begin();iter!=p.end();iter++)
    if(iter->GetDegree()==Degree(p))
      {
	if(iter->GetCoeff()*iter->GetCoeff()>max) {
	  max=iter->GetCoeff()*iter->GetCoeff();
	  //cout<<"newmax "<<max<<endl;
	  //cout<<" les monomes "<<*iter<<endl;
	  stockpos=iter;
	}
      }
  //break;
  //return *iter;
  return *stockpos;
}
template<typename pol>
typename pol::monom_t choice_dlex(const pol & p)
{
  typename pol::const_iterator iter;//
  std::list<typename pol::monom_t> tmp;
  typename pol::monom_t m; 
  //int maxtmpdeg=0;
  for(iter=p.begin();iter!=p.end();iter++)
    if(iter->GetDegree()==Degree(p))
      {
	tmp.push_back(*iter);
      }
  m=tmp.front();
  for(typename std::list<typename pol::monom_t>::iterator itertmp=tmp.begin();itertmp!=tmp.end();itertmp++)
    {
      if(my_ord(*itertmp,m)<0) {m=*itertmp;};
    }
  return m;
}

template<typename pol>
typename pol::monom_t choice_dinvlex(const pol & p)
{
  typename pol::const_iterator iter;//
  std::list<typename pol::monom_t> tmp;
  typename pol::monom_t m; 
  //int maxtmpdeg=0;
  for(iter=p.begin();iter!=p.end();iter++)
    if(iter->GetDegree()==Degree(p))
      {
	tmp.push_back(*iter);
      }
  m=tmp.front();
  for(typename std::list<typename pol::monom_t>::iterator itertmp=tmp.begin();itertmp!=tmp.end();itertmp++)
    {
      if(my_ord(*itertmp,m)>0) {m=*itertmp;};
    }
  return m;
}

template<typename pol>
typename pol::monom_t choice(const pol & p)
{
  typename pol::const_iterator iter;//
  std::list<typename pol::monom_t> tmp;
  typename pol::monom_t tmpmon=*p.begin(); 
  int maxtmpdeg=-1;
  for(iter=p.begin();iter!=p.end();iter++)
    if(degree(*iter)==degree(p))
      {
	tmp.push_back(*iter);
      }
  for(typename std::list<typename pol::monom_t>::iterator itertmp=tmp.begin();itertmp!=tmp.end();itertmp++)
    {
      for(int i=0;i<=lvar(itertmp->rep());i++)
	{
	  if((*itertmp)[i]>maxtmpdeg)
	    {
	      maxtmpdeg=(*itertmp)[i];
	      tmpmon=*itertmp;
	    }
	}
    }
  return tmpmon;
}

template<typename pol>
typename pol::monom_t choice_mix(const pol & p)
{
  static unsigned int compt=0;
  compt++;
  if((compt/3)%2) return choice_dlex(p);
  return choice_mac(p);
}



#if 1
template<typename pol>
typename pol::monom_t choice_mpq(const pol & p)
{
  typename pol::const_iterator iter,stockpos=p.begin();
  int mini=INT_MAX;
  for(iter=p.begin();iter!=p.end();iter++)
    if(iter->GetDegree()==degree(p))
      {
	if(mpz_size(mpq_numref(&(iter->GetCoeff().rep())))+
	   mpz_size(mpq_denref(&(iter->GetCoeff().rep())))<mini) {
	  mini=mpz_size(mpq_numref(&(iter->GetCoeff().rep())))+
	    mpz_size(mpq_denref(&(iter->GetCoeff().rep())));
	  //cout<<"newmax "<<max<<endl;
	  //cout<<" les monomes "<<*iter<<endl;
	  stockpos=iter;
	}
      }
  //break;
  //return *iter;
  return *stockpos;
}
#endif


__END_NAMESPACE_SYNAPS

