template< 
  bool single,
  bool half,
  class VertexData, 
  class EdgeData,
  template<class> class V, template<class> class E>
>
struct graph_base
{
  struct Vertex;
  typedef V<Vertex> VertexSet;
  typedef typename VertexSet::ref VertexRef;
  struct Edge;
  typedef E<Edge>   EdgeSet;
  typedef typename EdgeSet::ref   EdgeRef;
  
  
  struct Vertex
  {
    VertexData value;
    EdgeSet    neigh;
  };
  
  struct Edge
  {
    EdgeData  value;
    VertexRef neigh;
  };
  
  VertexRef insert( const VertexData & data = VertexData() ) { return insert(V,data); };
  void insert( VertexRef a, VertexRef b, const EdgeData & v = EdgeData() ) 
  { insert( access(V,a).neigh, Edge(v,b) ); };
  
  void remove( VertexRef v )
  {
    if ( simple ) 
      {
	Vertex & n(access(V,r));
	for ( typename EdgeSet::iterator it = n.neigh.begin(); it != n.neigh.end(); it ++ )
	  {
	    remove_neighbor(it
	  };
      };
  };
};


template<typename vertex_ref, typename edge_ref>
struct id_graph
{
  struct vertex { int pos; VertexRef ref; };
  struct edge   { int id;  EdgeRef   ref; };
  
  std::vector<vertex> head;
  std::vector<edge> next;
  
};


template<class Graph>

int n = g.nbVertices();
head.resize(n+1);
i = 0;
for ( G::vertex_ref it = g.begin(); it != g.end(); it ++ )
{
  it->extra   = i++;
  head[i].ref = it;
  for ( edge_ref eit = g.begin( it ); eit != g.end( it ); eit ++ )
    next.push_back(it->extra);
  head[i+1] = next.size();
};


	  
