#ifndef SYNAPS_ISHAPE_FACTORY_H
#define SYNAPS_ISHAPE_FACTORY_H
#include <synaps/init.h>
#include <list>
#include <synaps/shape/interfaces/IShape.h>
__BEGIN_NAMESPACE_SYNAPS

struct IShapeFactory
{
  virtual IShape * interface( const char * interface_name_, const char * representation_name_ = 0 )  = 0;
  virtual std::list< IShape* > representations ( const char * interface_name_ )  = 0;
};

__END_NAMESPACE_SYNAPS
#endif
