/** \example TopSbdBdg2d.cc **/

#include <synaps/topology/TopSbdBdg2d.h>

int main(int argc, char** argv) 
{
  MPol<QQ> p("x^6+3*x^4*y^2+3*x^2*y^4+y^6-4x^2*y^2");
  topology::point_graph<double> g;
  topology::assign(g, p, TopSbdBdg2d<double>(), 
		   -2., 2.1, -2.2, 2., 2);
}
