#include "synaps/upol/UPolDse.h"
#include "synaps/upol/gcd.h"
#include "synaps/upol/square_free.h"

typedef UPolDse<ZZ> upol_t;

int main (int argc, char **argv)
{
  using std::cout;  using std::endl;


  upol_t p0("4*x^2+6*x+2;"), p1("10*x^3+8*x^2-2*x");
  
  cout<<"p0 ="<<p0<<endl;
  cout<<"p1 ="<<p1<<endl;

  cout<<"gcd ="<<gcd(p0,p1)<<endl;
  cout<<"lcm ="<<lcm(p0,p1)<<endl;

  upol_t p2=p0*p0*p1;
  cout <<square_free(p2)<<endl;
  cout <<square_free_factorisation(p2)<<endl;

  assert((p0*p1-gcd(p0,p1)*lcm(p0,p1))==0);
  
}
