#include <iostream>
#include <string>
#include <synaps/arithm/gmp.h>
#include <synaps/upol/UPolDse.h>
#include <synaps/upol/xml.h>
#include <synaps/usolve/bezier/IslBzBdg.h>
#include "usolver.h"

int main(int argc, char** argv) 
{
  typedef ZZ               coeff_t;
  typedef UPolDse<coeff_t> upol_t;
  typedef IslBzBdg<double> solver_t;

  run_solver<upol_t>(argc,argv,solver_t());

}


