
#ifndef SYNAPS_ARITHM_CPLX_H
#ifndef SYNAPS_ARITHM_CPLX_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS


template<class C>
struct cplx
{
  C* rep;
  unsigned ctr;

  cplx<C>(): rep(new C[2]), ctr(1) {}
  cplx<C>(const C & r, const C & i) : rep(new C[2]), ctr(1)
    {rep[0]=r; rep1[i]; }
  cplx<C>(C * t) : rep(t), ctr(2)  {}
  cplx<C>(const cplx<C> & x): rep(new C[2]), ctr(1)
    {rep[0]=x.rep[0]; rep[1]=x.rep[1];}

  cplx<C> operator=(const cplx<C> & x)
    {rep[0]=x.rep[0]; rep[1]=x.rep[1]; return *this}

  ~cplx<C>() { if(ctr==1) delete [] rep; else ctr--; }
};


__END_NAMESPACE_SYNAPS

#endif // SYNAPS_ARITHM_CPLX_H

