
#define TEXP_DCL2(OP,X,Y) texp< texpb< OP, texp<X >, texp<Y> > >
#define TEXP_RETURN2(OP,X,Y,a,b) return texp< texpb< OP, texp<X >, texp<Y> > > ( texp<X>(a), texp<Y>(b) )
#define TEXP_NEG(HEAD,X)\
  HEAD inline texp< texpu< _neg_, texp<X> > >\
  operator-( const X & x )\
  { return texp< texpu< _neg_, texp<X> > >( texp<X>(x) ); };

#define TEXP_ADD(HEAD,X,Y)\
HEAD inline texp< texpb< _add_ , texp< X >, texp< Y > > >\
operator+( const X & x, const Y & y )\
{ return texp< texpb< _add_, texp< X >, texp< Y > > >(texp< X >(x),texp< Y >(y)); };\
HEAD inline texp< texpb< _add_ , texp< X >, texp< Y > > >\
operator+( const texp<X> & x, const Y & y )\
{ return texp< texpb< _add_, texp< X >, texp< Y > > >(x,texp<Y>(y)); };\
HEAD inline texp< texpb< _add_ , texp< X >, texp< Y > > >\
operator+( const X & x, const texp<Y> & y )\
{ return texp< texpb< _add_, texp< X >, texp< Y > > >(texp< X >(x),y); }

#define TEXP_SUB(HEAD,X,Y)\
HEAD inline texp< texpb< _sub_ , texp< X >, texp< Y > > >\
operator-( const X & x, const Y & y )\
{ return texp< texpb< _sub_, texp< X >, texp< Y > > >(texp< X >(x),texp< Y >(y)); };\
HEAD inline texp< texpb< _sub_ , texp< X >, texp< Y > > >\
operator-( const texp<X> & x, const Y & y )\
{ return texp< texpb< _sub_, texp< X >, texp< Y > > >(x,texp< Y >(y)); };\
HEAD inline texp< texpb< _sub_ , texp< X >, texp< Y > > >\
operator-( const X & x, const texp<Y> & y )\
{ return texp< texpb< _sub_, texp< X >, texp< Y > > >(texp<X>(x),y); };

#define TEXP_MUL(HEAD,X,Y)\
HEAD inline texp< texpb< _mul_ , texp< X >, texp< Y > > >\
operator*( const X & x, const Y & y )\
{ return texp< texpb< _mul_, texp< X >, texp< Y > > >(texp< X >(x),texp< Y >(y)); };\
HEAD inline texp< texpb< _mul_ , texp< X >, texp< Y > > >\
operator*( const texp<X> & x, const Y & y )\
{ return texp< texpb< _mul_, texp< X >, texp< Y > > >(x,texp< Y >(y)); };\
HEAD inline texp< texpb< _mul_ , texp< X >, texp< Y > > >\
operator*( const X & x, const texp<Y> & y )\
{ return texp< texpb< _mul_, texp< X >, texp< Y > > >(texp< X >(x),y); };

#define TEXP_DIV(HEAD,X,Y)\
HEAD inline texp< texpb< _div_ , texp< X >, texp< Y > > >\
operator/( const X & x, const Y & y )\
{ return texp< texpb< _div_, texp< X >, texp< Y > > >(texp< X >(x),texp< Y >(y)); };\
HEAD inline texp< texpb< _div_ , texp< X >, texp< Y > > >\
operator/( const texp<X> & x, const Y & y )\
{ return texp< texpb< _div_, texp< X >, texp< Y > > >(x,texp< Y >(y)); };\
HEAD inline texp< texpb< _div_ , texp< X >, texp< Y > > >\
operator/( const X & x, const texp<Y> & y )\
{ return texp< texpb< _div_, texp< X >, texp< Y > > >(texp< X >(x),y); };

#define TEXP_POW(HEAD,X,Y)\
HEAD inline texp< texpb< _pow_, texp<X>, texp<Y> > >\
operator^( const X & x, const Y & y )\
{ return texp< texpb< _pow_, texp<X>, texp<Y> > >( texp<X>(x), texp<Y>(y) ); };\
HEAD inline texp< texpb< _pow_, texp<X>, texp<Y> > >\
operator^( const texp<X> & x, const Y & y )\
{ return texp< texpb< _pow_, texp<X>, texp<Y> > >( x, texp<Y>(y) ); };\
HEAD inline texp< texpb< _pow_, texp<X>, texp<Y> > >\
operator^( const X & x, const texp<Y> & y )\
{ return texp< texpb< _pow_, texp<X>, texp<Y> > >( texp<X>(x), y ); }\

#define TEXP_MOD(HEAD,X,Y)\
HEAD inline texp< texpb< _mod_, texp<X>, texp<Y> > >\
operator%( const X & x, const Y & y )\
{ return texp< texpb< _mod_, texp<X>, texp<Y> > >( texp<X>(x), texp<Y>(y) ); };\
HEAD inline texp< texpb< _mod_, texp<X>, texp<Y> > >\
operator%( const texp<X> & x, const Y & y )\
{ return texp< texpb< _mod_, texp<X>, texp<Y> > >( x, texp<Y>(y) ); };\
HEAD inline texp< texpb< _mod_, texp<X>, texp<Y> > >\
operator%( const X & x, const texp<Y> & y )\
{ return texp< texpb< _mod_, texp<X>, texp<Y> > >( texp<X>(x), y ); }
