#ifndef SYNAPS_ARITHM_INTEGEROF_H
#define SYNAPS_ARITHM_INTEGEROF_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X>
  struct integerof_ { typedef int T; };
  template<class K, class X>
  struct kernel_integerof { typedef typename K::integer T; };
  template<class X>
  struct kernel_integerof<null_t,X> { typedef typename integerof_<X>::T T; };
  template<class X>
  struct integerof
  {
    typedef typename ucstref<X>::T _X;
    typedef typename kernel_integerof< typename kernelof<X>::T, _X  >::T T;
  };
  
};

__END_NAMESPACE_SYNAPS

#endif
