#include <synaps/arithm/Interval.h>

typedef Interval<double> interval_t; 
int main(int argc, char** argv) 
{
  Interval<double> u(1.1,2), r;
  Interval<int>    v(-1,-2);
  int x=2;double y=2.1;
  r=u+v;
  std::cout<<r<<std::endl;
  r=u*v;
  std::cout<<r<<std::endl;
  r=u+x;
  std::cout<<u<<"+"<<x<<"= "<<r<<std::endl;
  assert(r.lower()==u.lower()+x);
  assert(r.upper()==u.upper()+x);

  r=u+y;
  std::cout<<u<<"+"<<y<<"= "<<r<<std::endl;

  v+=-1;
  std::cout<<v<<std::endl;
  assert(v==Interval<int>(-3,-2));
}
