<TeXmacs|1.0.6>

<style|article>

<\body>
  <section|How to configure synaps>

  Once you get the file <verbatim|synaps-xxx.tar.gz> by ftp, type

  <\code>
    tar zxvf synaps-xxx.tar.gz
  </code>

  Then move in the directory <verbatim|synaps-xxx> and type\ 

  <\code>
    ./configue; make && make install
  </code>

  To see the different options of the configuration, type
  <verbatim|./configure -h>

  <\code>
    ./configure\ 

    \ \ \ \ --with-blas= [where is the libblas.a]\ 

    \ \ \ \ --with-lapack= [where is the liblapack.a]\ 

    \ \ \ \ --with-gmp= [where is the directory gmp]\ 

    \ \ \ \ --with-mpsolve= [where is the directory mpsolve]\ 

    \ \ \ \ --infodir= [where to install the documentation, with make
    install]\ 

    \ \ \ \ --bindir= [where to install s++, with make install]\ 

    \ \ \ \ --prefix= [where to install the rest of the library]
  </code>

  \;
</body>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|1.1|?>>
    <associate|auto-3|<tuple|1.1.1|?>>
    <associate|auto-4|<tuple|1.1.2|?>>
    <associate|auto-5|<tuple|1.3.1|?>>
    <associate|auto-6|<tuple|1.3.2|?>>
    <associate|auto-7|<tuple|1.4|?>>
    <associate|auto-8|<tuple|1.5|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <vspace*|1fn><with|font-series|<quote|bold>|math-font-series|<quote|bold>|1<space|2spc>How
      to download and \ install the library>
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.5fn>

      <with|par-left|<quote|1.5fn>|1.1<space|2spc>How to get it
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2>>

      <with|par-left|<quote|1.5fn>|1.2<space|2spc>How to configure it
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-3>>

      <with|par-left|<quote|1.5fn>|1.3<space|2spc>How to use it
      \ <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-4>>

      <with|par-left|<quote|3fn>|1.3.1<space|2spc>Options of compilation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-5>>

      <with|par-left|<quote|3fn>|1.3.2<space|2spc>Check the installation
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-6>>
    </associate>
  </collection>
</auxiliary>