#include <synaps/init.h>
#ifdef SYNAPS_WITH_LAPACK
#include <iostream>
#include <synaps/linalg/lapack.h>
#include <synaps/linalg/MatrDse.h>
#include <synaps/linalg/Eigen.h>
#include <synaps/linalg/Svd.h>

typedef VectDse<double> vect_t;
typedef MatrDse<double,lapack::rep2d<double> > matr_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  matr_t A(3,3,"1 2 3 4 5 6 7 8 9",ByRow());
  cout<<A<<endl;
  cout<< Svd(A)<<endl;
  cout<< Eigenval(A)<<endl;
}
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_LAPACK

