#include <synaps/init.h>
#ifdef SYNAPS_WITH_GMP
#include "synaps/arithm/QQ.h"
#include "synaps/mpol.h"
typedef MPol<QQ>   mpol_t;

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;

  mpol_t a("x1^2*x0+2*x1+3"), b("x1^2+123*x2");
  a *= b;
  cout<<a<<endl;
  VECTOR::print(cout,a)<<endl;
  for(mpol_t::iterator it=a.begin(); it !=a.end(); it++)
    cout<<it->coeff()<<" ";
  cout<<endl;
  for(mpol_t::iterator it =a.begin(); it !=a.end();it++)
  it->coeff()*=it->coeff();
  cout<<a<<endl;

} 
#else
int main(int argc, char** argv) {}
#endif //SYNAPS_WITH_GMP
