
#include <iosfwd>
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS

namespace linalg {
//----------------------------------------------------------------------
template <class C>
rep2d<C>::rep2d(const char * nm)
{
	std::ifstream ins(nm, std::ios::in);
  ins >> nbrow_ >> nbcol_;
  this->size_ = this->nbrow_*this->nbcol_; this->tab_ = new C[this->size_];

  for(size_type i=0; i< this->size_; i++) ins >>this->tab_[i];
  ins.close();
}
//----------------------------------------------------------------------
template <class C>
rep2d<C> & rep2d<C>::operator=(const rep2d<C> & v) 
{
  this->rep1d<C>::operator=(v);
  this->nbrow_ = v.nbrow(); this->nbcol_ = v.nbcol();
  return *this;
}
//----------------------------------------------------------------------
} //CLOSE linalg

__END_NAMESPACE_SYNAPS

