#define USING_NAMESPACE_SYNAPS 1

#include<cstdlib>
#include<iostream>
#include "synaps/mpol.h"
#include "synaps/linalg.h"

int main()
{
	MatrSps<double> toto(5,5),L,U;
	for(int i=0;i<5;i++)
	 for(int j=0;j<5;j++)
	 	toto.rep()(i,j,i+j);

	MATRIX::print(std::cout,toto);  std::cout<<std::endl;

	sparse::decomp(LU(),toto.rep(), L.rep(), U.rep());

	MATRIX::print(std::cout,toto);   std::cout<<std::endl;

	toto.rep().destroystore();
	L.rep().destroystore();
	U.rep().destroystore();
}
