/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): B. Mourrain, GALAAD, INRIA
 *   $Id: $
 ********************************************************************/
#ifndef synaps_mpol_AllVariables_H
#define synaps_mpol_AllVariables_H
//===================================================================
#include <synaps/init.h>
#include <string>
#include <sstream>
//===================================================================
__BEGIN_NAMESPACE_SYNAPS
//===================================================================
template<char v>
struct AllVariables 
{
  AllVariables(){}
  std::string  operator[](int i) const
  {
    int sz=1,m=1;
    while(m<i) {m*=10; sz++;}
    char str[sz+1];
    sprintf(str,"d%d",i);
    return std::string(str);
  }
};
__END_NAMESPACE_SYNAPS
#endif // synaps_mpol_AllVariables_h
