#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS



template<>
void INIT_ELEM<pol<mon,Scl<MPQ> > >(void *ptr, int size)
{
  typedef pol<mon,Scl<MPQ> > pol;
  int nbelem=size/sizeof(pol),k=0;
  for(pol *i=(pol*)ptr;k<nbelem;i++,k++)
    mpq_init(&((i->ind).coeff.rep()));
}
template<>
void INIT_ELEM<Scl<MPQ> >(void * ptr, int size)
{
  int nbelem=size/sizeof(Scl<MPQ>),k=0;
  for(Scl<MPQ> *i=(Scl<MPQ> *)ptr;k<nbelem;i++,k++)
       mpq_init(&i->rep())
    ;
}
template<>
void CLEAR_ELEM<Scl<MPQ> >(void * ptr, int size)
{
  //cout<<"clear elem "<<endl;
  int nbelem=size/sizeof(Scl<MPQ>),k=0;
  for(Scl<MPQ> *i=(Scl<MPQ>*)ptr;k<nbelem;i++,k++)
    mpq_clear(&i->rep());
}

//template<>
//void CLEAR_ELEM<pol<mon,Scl<MPQ> > >(void *ptr, int size)
//{
//  typedef pol<mon,Scl<MPQ> > pol;
//  typedef pol::coeff_t coeff;
//  int nbelem=size/sizeof(pol),k=0;
//  for(pol *i=(pol*)ptr;k<nbelem;i++,k++)
//    {
//      mpq_clear(&((i->ind).coeff.rep()));
//      MAC_REV_FREE<coeff>(i->nf,i->size*sizeof(coeff));
//    }
//}


__END_NAMESPACE_SYNAPS


