#include <synaps/init.h>
#include <synaps/bignum.h>
#include <iostream>
#include <stdio.h>
#include <list>
#include <vector>
#include <map>
#include <synaps/mpol.h>
#include <time.h>
//#include <synaps/base/Clock.h>
#include "genmacrev.h"


__BEGIN_NAMESPACE_SYNAPS

template<typename Base,typename typdump> 
int countpoint(const Base &b,const typdump & dump)
{
  typedef typename typdump::value_type::pol_t pol;
  typedef typename pol::monom_t mon;
  int maxdeg=0;
  std::list<mon> current;
  std::list<mon> stockmon;
  current.push_back(mon(1));
  stockmon.push_back(mon(1));
  {
    typename typdump::const_iterator iter;
      for(iter=dump.begin();
	  iter!=dump.end();iter++);
    maxdeg=(--iter)->k;
  }
  //on a le degre max
  //le quotient est connexe a 1 donc on par t 
  //de 1 et on decrit le reste en multipliant par les variables
  for(int i=0;i<=maxdeg;i++)
    {
      std::list<mon> tmpcurrent=current;
      //my_merge(stockmon,current);
      current.erase(current.begin(),current.end());
      for(int i=0;i<b.nbvar();i++)
	{
	  for(typename std::list<mon>::iterator iter=tmpcurrent.begin();
	      iter!=tmpcurrent.end();iter++)
	    current.push_back((*iter)*mon(i,1));
	}
      //maintenant on tri;
      for(typename std::list<mon>::iterator iter=current.begin();iter!=current.end();iter++)
	if((IsinB(*iter,b))&&(!member(stockmon,*iter)))
	  {
	    stockmon.push_back(*iter);
	  }
      else
	{
	  current.erase(iter--);
	}
    }
  return stockmon.size();
}

template<typename Base,typename typdump,typename typMk> 
void MonomialBase(const Base &b,const typdump & dump,typMk & res)
{
  typedef typename typdump::value_type::pol_t pol;
  typedef typename pol::monom_t mon;
  int maxdeg=0;
  std::list<mon> current;
  //  std::list<mon> stockmon;
  current.push_back(mon(1));
  res.push_back(mon(1));
  {
    typename typdump::const_iterator iter;
      for(iter=dump.begin();
	  iter!=dump.end();iter++);
    maxdeg=(--iter)->k;
  }
  //on a le degre max
  //le quotient est connexe a 1 donc on par t 
  //de 1 et on decrit le reste en multipliant par les variables
  for(int i=0;i<maxdeg;i++)
    {
      std::list<mon> tmpcurrent=current;
      //my_merge(stockmon,current);
      current.erase(current.begin(),current.end());
      for(int i=0;i<b.nbvar();i++)
	{
	  for(typename std::list<mon>::iterator iter=tmpcurrent.begin();
	      iter!=tmpcurrent.end();iter++)
	    current.push_back((*iter)*mon(i,1));
	}
      //maintenant on tri;
      for(typename std::list<mon>::iterator iter=current.begin();iter!=current.end();iter++)
	if((IsinB(*iter,b))&&(!member(res,*iter)))
	  {
	    res.push_back(*iter);
	  }
      else
	{
	  current.erase(iter--);
	}
    }
  return;
}

__END_NAMESPACE_SYNAPS


