/********************************************************************
 *   This file is part of the source code of the SYNAPS library.
 *   Author(s): J.P. Pavone, GALAAD, INRIA
 *   $Id: method_base.hpp,v 1.1 2005/07/11 10:03:55 jppavone Exp $
 ********************************************************************/
#ifndef SYNAPS_SOLVE_SBDSLV_METHOD_BASE_HPP
#define SYNAPS_SOLVE_SBDSLV_METHOD_BASE_HPP
//--------------------------------------------------------------------
#include <synaps/init.h>
//--------------------------------------------------------------------
__BEGIN_NAMESPACE_SYNAPS
//--------------------------------------------------------------------
namespace sbdslv
{
  /* interface system -> methode */
  struct method_base
  { 
    virtual void error( const char * ) = 0;
    virtual void accept() = 0;
    virtual ~method_base() {};
  };
}
//--------------------------------------------------------------------
__END_NAMESPACE_SYNAPS
/********************************************************************/
#endif //
