#ifndef SYNAPS_SHAPE_FPARAMETRIC_H
#define SYNAPS_SHAPE_FPARAMETRIC_H

__BEGIN_NAMESPACE_SYNAPS

template<class Scalar> 
void tsample( Scalar * t, const Scalar&  a_, const Scalar & b, int n )
{
  Scalar a = a_;
  Scalar h = (b-a)/Scalar(n-1);
  for ( Scalar * p = t; p != t + n; *p++ = a, a += h );
};


__END_NAMESPACE_SYNAPS

#endif
