#ifndef SYNAPS_SHAPE_IBSPLINE_CURVE_H
#define SYNAPS_SHAPE_IBSPLINE_CURVE_H

#include "IParametricCurve.h"

__BEGIN_NAMESPACE_SYNAPS

struct IBSplineCurve : IParametricCurve
{
  typedef IParametricCurve base_t;
  virtual void setDefinition( int nbpt, int order, const double * knots, const double * coeffs  ) = 0;
};

__END_NAMESPACE_SYNAPS

#endif
