#ifndef SYNAPS_SHAPE_RATIONAL_CURVE_H
#define SYNAPS_SHAPE_RATIONAL_CURVE_H

#include "IParametricCurve.h"

__BEGIN_NAMESPACE_SYNAPS

struct IRationalCurve : IParametricCurve
{
  typedef IParametricCurve base_t;
  virtual void setRange( double a, double  b ) = 0;
  virtual void setEquations( const char * w, 
			     const char * x, 
			     const char * y, 
			     const char * z ) = 0;
  //  virtual void setEquation ( int n, const double * coeffs, int sz  ) = 0;
  
};
__END_NAMESPACE_SYNAPS
#endif
