#ifndef SYNAPS_SHAPE_IRATIONAL_SURFACE_H
#define SYNAPS_SHAPE_IRATIONAL_SURFACE_H

#include <synaps/shape/interfaces/IParametricSurface.h>

__BEGIN_NAMESPACE_SYNAPS

struct IRationalSurface : IParametricSurface
{
  typedef IParametricSurface base_t;
  virtual bool setRange( double umin, double umax, double vmin, double vmax )                          = 0;
  virtual void setEquations( const char * w, const char * x, const char * y, const char *  z, const char * variables ) = 0;
};

__END_NAMESPACE_SYNAPS
#endif
